var QT = window.QueryTool = function() {
	return this;
};
QT.prototype = {
	setting : {
		MAX_PAGES : 1000, // 最多显示页数
		hasMore : false,
		hasPrev : false,
		scrollFlag : "next",
		waitFlag : false,
		ctx : '',
		url : '',
		queryPageId : 'pageA',
		resultPageId : 'pageB',
		isButtonEvent : false,
		alertEmpty : false,
		activeName : '滑动',
		alertEmptyMsg : '沒有符合查詢條件的信息!',
		showAjaxError : false,
		isLoad : false,
		listLabel : "List",
		sendStr : null,
		transMsgDivId : "transMsg",// 显示错误的交易信息
		targetDivId : "recordListDiv", // 数据加载的显示区ID
		loadDivId : "loading", // 等待显示区ID
		preloadDivId : "prevloading" // 等待显示区ID
	},
	beginNumber : 1,
	queryNumber : 5,
	pageIndex : 0,
	topPageIndex : 0,
	botPageIndex : 0,
	targetDiv : null,
	loadDiv : null,
	preloadDiv : null,
	transMsgDiv : null,
	start : function(cfg) {
		// this.log("---start---");
		if (!cfg || !cfg.url || !cfg.sendStr || !cfg.loadNode) {
			alertinfo("请检查参数设置");
			return this;
		}
		//属性复制合并
		Fw.applyIf(this.setting,cfg);
		this.targetDiv = g(this.setting.targetDivId);
		// this.log("---start-2--");
		this.loadDiv = g(this.setting.loadDivId);
		this.preloadDiv = g(this.setting.preloadDivId);
		this.transMsgDiv = g(this.setting.transMsgDivId);
		// this.log("---start-3--");
		if (!this.targetDiv || !this.loadDiv || !this.preloadDiv
				|| !this.transMsgDiv) {
			alertinfo("请检查ID设置");
			return null;
		}
		this.clear();
		this.sendStr = this.setting.sendStr;
		this.loadNode = this.setting.loadNode;
		this.isButtonEvent = true;
		this.loadDiv.flag = 0;
		this.preloadDiv.flag = 0;
		this.pageQuery();
		this.initScroll();
		window._QT = this;
		// this.log("---start-2--");
		return this;
	},
	clear : function() {
		this.targetDiv.innerHTML = "";
		this.transMsgDiv.innerHTML = "";
	},
	toString : function() {
		var cfg = {};
		cfg.hasMore = this.hasMore;
		cfg.hasPrev = this.hasPrev;
		cfg.begin = this.beginNumber;
		cfg.pageSize = this.queryNumber;
		cfg.topPageIndex = this.topPageIndex;
		cfg.botPageIndex = this.botPageIndex;
		return JsonToStr(cfg);
	},
	distory : function() {
		window.onscroll = null;
	},
	initScroll : function() {
		// alert("---QT.initScroll---");
		if (getOSType() == 'android') {
			this.activeName = '点击';
			return;
		}
		var tmpQT = this;
		window.onscroll = function() {
			// alert("---QT.startScroll---");
			if (tmpQT.hasMore || tmpQT.hasPrev) {
				try {
					var body = document.body;
					body = body ? body : document.documentElement;
					var wh, sh, st;
					wh = body.clientHeight * 1;
					sh = body.scrollHeight * 1;
					st = body.scrollTop * 1;
					if ((wh + st) > (sh * 1 - 150)) {
						if (tmpQT.hasMore) {
							tmpQT.showMore("next");
						}
					} else if (st < 50) {
						if (tmpQT.topPageIndex > 0) {
							tmpQT.showMore("prev");
						}
					}
				} catch (e) {
					alertinfo("QT.onscroll error!");
				}
			}
		};
	},
	showMore : function(f) {
		var msg = 1;
		try {
			// 设置起止页码
			if (this.isLoad) {
				return;
			}
			this.isLoad = true;
			var flag = f ? f : this.scrollFlag;
			this.scrollFlag = flag;
			if (!this.waitFlag) {
				try {
					setWaitPanel();
				} catch (e) {
				}
			}
			this.isButtonEvent = false;
			msg = 2;
			if (flag == "prev") {
				if (this.topPageIndex <= 0) {
					this.preloadDiv.flag = 0;
					this.isLoad = false;
					return;
				}
				msg = 3;
				this.loadDiv.flag = 0;
				if ((this.botPageIndex - this.topPageIndex) >= this.MAX_PAGES) {
					this.isScroll = true;
					this.topPageIndex--;
					this.botPageIndex--;
				}
				msg = 4;
				this.pageIndex = this.topPageIndex;
			} else if (flag == "next") {
				if ((this.botPageIndex - this.topPageIndex) >= this.MAX_PAGES) {
					this.topPageIndex++;
					this.hasPrev = true;
				}
				msg = 5;
				this.botPageIndex++;
				this.pageIndex = this.botPageIndex;
				msg = 6;
			}

			msg = 7;
			this._anim();
			msg = 8;
			this.beginNumber = 1 + (this.pageIndex * this.queryNumber);
			msg = 9;
			this.pageQuery();
		} catch (e) {
			this.log("QT.showMore error:" + msg);
		}
	},
	log : function(msg) {
		alert("QT \n" + msg);
	},
	_anim : function() {
		var nextDown = g("QT_NEXT_DOWN");
		if (nextDown) {
			addClass(nextDown, "arrowDown");
		}
		if (this.hasPrev) {
			var prevDown = g("QT_PREV_DOWN");
			if (prevDown) {
				addClass(prevDown, "arrowDown");
			}
		}
	},
	distroy : function() {
		window.onscroll = null;
	},
	pageQuery : function() {
		// 执行数据加载
		// this.log(this.toString());
		var beginNumber = this.beginNumber;
		var sendObj = eval("(" + this.sendStr + ")");
		sendObj['pageSize'] = "" + this.queryNumber; // 頁大小
		sendObj['startId'] = "" + beginNumber; // 起始記錄
		var strEncrypt = JsonToStr(sendObj);
		var ajax = new TransAjax();
		ajax.setArgs(this);
		ajax.setShowError(this.showAjaxError);
		ajax.sendPostData(this.url, strEncrypt, function(rpdata) {
			var tmpQT = ajax.getArgs();
			try {
				tmpQT.showList(rpdata);
			} catch (e) {
				alert("showList \n" + e);
			}
			tmpQT.isLoad = false;
		});
	},
	loadNode : function(node) {
		return "<ul><li>--customer overwrite QT.loadNode--</li></ul>";
	},
	showList : function(rpdata) {
		// 返回记录数据小于查询笔试，则停止翻页处理
		var list = "";
		if (rpdata && rpdata[this.listLabel]
				&& rpdata[this.listLabel].length > 0) {
			var nodes = rpdata[this.listLabel];
			if (nodes.length >= this.queryNumber) {
				this.hasMore = true;
			} else {
				this.hasMore = false;
			}
			var trueSize = nodes.length;
			var start = this.pageIndex * this.queryNumber + 1;
			for ( var i = 0, j = trueSize; i < j; i++) {
				try {
					list += this.loadNode(nodes[i], start + i);
				} catch (e) {
					alert("QT loadNode error : \n" + e);
				}
			}
		} else {
			this.hasMore = false;
			if (this.pageIndex == 0) {
				if (this.alertEmpty) {
					alertinfo(this.alertEmptyMsg);
				} else {
					g(this.transMsgDivId).innerHTML = this.alertEmptyMsg;
				}
			} else {
				addClass(this.preloadDiv, "hiden");
				this.loadDiv.innerHTML = "<div align='center' class='wf100'><span style='padding-top: 10px'>數據加載已完成。</span></div>";
			}
		}
		try {
			// 查询结束统一处理
			this.searchFinished(list, rpdata);
		} catch (e) {
			alert("searchFinished \n" + e);
		}
	},
	searchFinished : function(listHtml, rpdata) {
		var div = this.targetDiv;
		if (div) {
			var html = this.addChildItem(div.id, listHtml);
			if (null != html && "" != html) {
				div.innerHTML = html;
			}
		}
		if (this.hasMore) {
			this._loadNextHtml(1);
			if (this.topPageIndex <= 0) {
				addClass(this.preloadDiv, "hiden");
				this.hasPrev = false;
			} else {
				this.hasPrev = true;
				this._loadPrevHtml(1);
				removeClass(this.preloadDiv, "hiden");
			}
		} else {
			if (this.topPageIndex <= 0) {
				addClass(this.preloadDiv, "hiden");
			} else {
				this._loadPrevHtml(1);
				removeClass(this.preloadDiv, "hiden");
			}
			this.loadDiv.flag = 0;
			if (this.pageIndex == 0 && listHtml == "") {
				this.loadDiv.innerHTML = "";
			} else {
				this.loadDiv.innerHTML = "<div align='center' class='wf100'><span style='padding-top: 10px'>數據加載已完成!</span></div>";
			}
		}
		if (this.isButtonEvent) {
			// 清空历史数据
			if (listHtml != "") {
				removeClass(g(this.resultPageId), "hiden");
				addClass(g(this.queryPageId), "hiden");
				// 自定义处理
				try {
					this.afterShowResult(rpdata);
				} catch (e) {
					alert("afterShowResult error!");
				}
			} else {
				if (this.alertEmpty) {
					alertinfo(this.alertEmptyMsg);
				} else {
					var transMsgDiv = g(this.transMsgDivId);
					removeClass(transMsgDiv, "hiden");
					transMsgDiv.innerHTML = this.alertEmptyMsg;
					setTimeout("clearWaitPanel(1)", 200);
				}
				// 自定义处理
				this.afterShowEmpty(rpdata);
			}
		} else {
			if (!this.waitFlag) {
				setTimeout("clearWaitPanel(2)", 200);
			}
		}
		// 自定义处理
		try {
			this.afterPageQuery(rpdata);
		} catch (e) {
			alert("afterPageQuery error!");
		}
	},
	_loadNextHtml : function(flag) {
		try {
			var loadDiv = this.loadDiv;
			if (loadDiv.flag == flag) {
				setTimeout(function() {
					removeClass("QT_NEXT_DOWN", "arrowDown");
				}, 200);
			} else {
				loadDiv.flag = flag;
				loadDiv.innerHTML = "<div align='center' onclick='_QT.showMore(\"next\")' class='h50 wf100'>"
						+ this._arrowDown("QT_NEXT_DOWN")
						+ "<span class='f-left' style='padding-top: 10px'>"
						+ this.activeName + "加载更多</span></div>";
			}
		} catch (e) {
			alert("_loadNextHtml error is :" + e);
		}
	},
	_loadPrevHtml : function(flag) {
		var preloadDiv = this.preloadDiv;
		if (preloadDiv.flag == flag) {
			setTimeout(function() {
				removeClass("QT_PREV_DOWN", "arrowDown");
			}, 200);
		} else {
			preloadDiv.flag = flag;
			preloadDiv.innerHTML = "<div align='center' onclick='_QT.showMore(\"prev\")' class='h50 wf100'>"
					+ this._arrowDown("QT_PREV_DOWN")
					+ "<span class='f-left' style='padding-top: 10px'>"
					+ this.activeName + "载入较早前记录</span></div>";
		}
	},
	addChildItem : function(id, itemHTML) {
		if (itemHTML == "") {
			if (this.topPageIndex > 0) {
				this.topPageIndex--;
			}
			if (this.botPageIndex > 0) {
				this.botPageIndex--;
			}
			return null;
		}
		var ulObj = g(id);
		var listHTML = "";
		if (this.topPageIndex != 0 || (this.topPageIndex == 0 && this.isScroll)) {
			var liItem = ulObj.getElementsByTagName("ul");
			if (this.scrollFlag == "next") {
				for ( var i = 0; i < this.queryNumber; i++) {
					var obj = liItem[0];
					ulObj.removeChild(obj);
				}
				listHTML = ulObj.innerHTML + itemHTML;
			} else {
				if (this.queryNumber != 0
						&& (liItem.length % this.queryNumber) != 0) {
					length_ = liItem.length - liItem.length % this.queryNumber;
				} else {
					length_ = liItem.length - this.queryNumber;
				}
				for ( var j = liItem.length - 1; j >= length_; j--) {
					var obj = liItem[liItem.length - 1];
					ulObj.removeChild(obj);
				}
				listHTML = itemHTML + ulObj.innerHTML;
			}
		} else {
			listHTML = ulObj.innerHTML + itemHTML;
		}
		// this.log(listHTML);
		return listHTML;
	},
	afterShowResult : function(rpdata) {
	},
	afterPageQuery : function(rpdata) {
	},
	afterShowEmpty : function(rpdata) {
	},
	openWaitFlag : function() {
		this.waitFlag = true;
	},
	closeWaitFlag : function() {
		// 关闭等待层控制器
		this.waitFlag = false;
	},
	_arrowDown : function(id) {
		return "<span class='f-left' style='width:30%;text-align:right;padding-right:5px;'><img id='"
				+ id
				+ "' style='height:50px;' src='"
				+ this.ctx
				+ "/styles/theme/images/blackArrowDown.png'></span>";
	}
};