(function(){
	//返回基本路径
	var getBasePath = window['_getBasePath'];
	//返回URL中的参数
	var _param = window['_getParameter'];
	var _pp = window['__pageParam'];
	//
	var config = {
		debug: true,//false时，加载/js/*-min.js
		version :  _param('v') || _pp['pv'] || 1,
		os: _param('os') || 'web',
		lang: _param('lang') || 'zh-CN'
	};
	var basePath = getBasePath();
	var scriptSuffix = config.debug ? '' : '-min';
	var vars = ['<script type="text/javascript" src="' + basePath + '/', scriptSuffix, (_param('v')||_pp['mv']||1) + '" charset="utf-8"></script>'];
	//框架脚本
	var html = '{0}js/seajs/sea{1}.js?v={2}';
	html += '{0}js/juicer/juicer{1}.js?v={2}';
	html += '{0}js/jquery/jquery-small{1}.js?v={2}';
	if(config.debug){
		//
		html += '{0}js/ytfw/core/Fw{1}.js?v={2}';
		html += '{0}js/ytfw/util/Observable{1}.js?v={2}';
		html += '{0}js/ytfw/util/DelayedTask{1}.js?v={2}';
		html += '{0}js/ytfw/util/JSON{1}.js?v={2}';
		html += '{0}js/ytfw/util/Ajax{1}.js?v={2}';
		html += '{0}js/ytfw/util/Format{1}.js?v={2}';
		html += '{0}js/ytfw/widget/Component{1}.js?v={2}';
		html += '{0}js/ytfw/widget/ListView{1}.js?v={2}';
		html += '{0}js/ytfw/widget/Toolbar{1}.js?v={2}';
		html += '{0}js/ytfw/widget/Group{1}.js?v={2}';
		html += '{0}js/ytfw/device/'+config.os+'{1}.js?v={2}';
	}else{
		html += '{0}js/ytfw/all/'+config.os+'{1}.js?v={2}';		
	}
	//
	html = html.replace(/\{(\d+)\}/g, function(m, i){
		return vars[i];
	});
	document.write(html);
	//
	window.addEventListener('DOMContentLoaded', function() {
		try{
			//框架配置
			Fw.getBasePath = getBasePath;
			Fw.getParameter = _param;
			Fw.apply(Fw, config);
			//SEA配置
			seajs.config({
				base: basePath, 
				vars: config,
				map: [[ /^(.*\.(?:css|js))(?:.*)$/i, '$1?v=' + config.version]]
			}); 
			//自动构建APP脚本
			//每个页面都绑定一个同名JS
			var path = document.location.href;
			path = path.substring(basePath.length + 1, path.lastIndexOf("."));
			var script = document.createElement('script');
			script.type = 'text/javascript';
			script.text = 'seajs.use(["'+path + '"]);';
			document.body.appendChild(script);
		}
		catch(e){
			alert(e);
		}
	}, false);
})();
